## ros-dashing-cartographer-ros 1.0.9003

=== CMakeLists.txt ===
# Copyright 2016 The Cartographer Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)

project(cartographer_ros)

find_package(ament_cmake REQUIRED)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(cartographer REQUIRED)
include("${CARTOGRAPHER_CMAKE_DIR}/functions.cmake")
set(BUILD_SHARED_LIBS OFF)
option(BUILD_GRPC "build features that require Cartographer gRPC support" false)

google_initialize_cartographer_project()
# google_enable_testing()

find_package(cartographer_ros_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(pcl_conversions REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(tf2_msgs REQUIRED)
find_package(visualization_msgs REQUIRED)

find_package(LuaGoogle REQUIRED)
find_package(PCL REQUIRED COMPONENTS common)
find_package(Eigen3 REQUIRED)
find_package(urdfdom_headers REQUIRED)

if(DEFINED urdfdom_headers_VERSION)
  if(${urdfdom_headers_VERSION} GREATER 0.4.1)
    add_definitions(-DURDFDOM_HEADERS_HAS_SHARED_PTR_DEFS)
  endif()
endif()

include_directories(
  include
  "."
)

# # Override Catkin's GTest configuration to use GMock.
# set(GTEST_FOUND TRUE)
# set(GTEST_INCLUDE_DIRS ${GMOCK_INCLUDE_DIRS})
# set(GTEST_LIBRARIES ${GMOCK_LIBRARIES})

# file(GLOB_RECURSE ALL_SRCS "*.cc" "*.h")
# file(GLOB_RECURSE ALL_TESTS "*_test.cc")
# file(GLOB_RECURSE ALL_EXECUTABLES "*_main.cc")
# list(REMOVE_ITEM ALL_SRCS ${ALL_TESTS})
# list(REMOVE_ITEM ALL_SRCS ${ALL_EXECUTABLES})

set(ALL_SRCS
  "cartographer_ros/map_builder_bridge.cc"
  "cartographer_ros/msg_conversion.cc"
  "cartographer_ros/node.cc"
  "cartographer_ros/node_constants.cc"
  "cartographer_ros/node_options.cc"
  "cartographer_ros/ros_log_sink.cc"
  "cartographer_ros/sensor_bridge.cc"
  "cartographer_ros/tf_bridge.cc"
  "cartographer_ros/time_conversion.cc"
  "cartographer_ros/trajectory_options.cc"
  "cartographer_ros/submap.cc"
)
add_library(${PROJECT_NAME} ${ALL_SRCS})
ament_target_dependencies(${PROJECT_NAME} PUBLIC
  cartographer_ros_msgs
  geometry_msgs
  nav_msgs
  pcl_conversions
  rclcpp
  sensor_msgs
  std_msgs
  tf2
  tf2_eigen
  tf2_msgs
  tf2_ros
  visualization_msgs
)
add_subdirectory("cartographer_ros")

target_link_libraries(${PROJECT_NAME} PUBLIC cartographer)

# Lua
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${LUA_INCLUDE_DIR})

# PCL
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${PCL_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${PCL_LIBRARIES})
set(BLACKLISTED_PCL_DEFINITIONS " -march=native -msse4.2 -mfpmath=sse ")
foreach(DEFINITION ${PCL_DEFINITIONS})
  list (FIND BLACKLISTED_PCL_DEFINITIONS "${DEFINITION}" DEFINITIONS_INDEX)
  if (${DEFINITIONS_INDEX} GREATER -1)
    continue()
  endif()
  set(TARGET_COMPILE_FLAGS "${TARGET_COMPILE_FLAGS} ${DEFINITION}")
endforeach()

# Eigen
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC
  "${EIGEN3_INCLUDE_DIR}")

# YAML
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${YAMLCPP_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${YAMLCPP_LIBRARIES})

# URDFDOM
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${urdfdom_headers_INCLUDE_DIRS})

# Add the binary directory first, so that port.h is included after it has
# been generated.
target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)

set(TARGET_COMPILE_FLAGS "${TARGET_COMPILE_FLAGS} ${GOOG_CXX_FLAGS}")
set_target_properties(${PROJECT_NAME} PROPERTIES
  COMPILE_FLAGS ${TARGET_COMPILE_FLAGS})

# install(PROGRAMS scripts/tf_remove_frames.py
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

install(DIRECTORY configuration_files
  DESTINATION share/${PROJECT_NAME}/
)

install(TARGETS
  ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

# # Install source headers.
# file(GLOB_RECURSE HDRS "*.h")
# foreach(HDR ${HDRS})
#   file(RELATIVE_PATH REL_FIL ${PROJECT_SOURCE_DIR} ${HDR})
#   get_filename_component(INSTALL_DIR ${REL_FIL} DIRECTORY)
#   install(
#     FILES
#       ${HDR}
#     DESTINATION
#       include/${INSTALL_DIR}
#   )
# endforeach()

ament_package()

=== cartographer_ros/CMakeLists.txt ===
# Copyright 2016 The Cartographer Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_executable(cartographer_node
  node_main.cc)
target_include_directories(cartographer_node SYSTEM PUBLIC ${LUA_INCLUDE_DIR})
target_link_libraries(cartographer_node ${PROJECT_NAME})
ament_target_dependencies(cartographer_node
  rclcpp
)

add_executable(occupancy_grid_node
  occupancy_grid_node_main.cc)
target_include_directories(occupancy_grid_node SYSTEM PUBLIC ${LUA_INCLUDE_DIR})
target_link_libraries(occupancy_grid_node ${PROJECT_NAME})
ament_target_dependencies(occupancy_grid_node
  cartographer_ros_msgs
  nav_msgs
  rclcpp
)

install(TARGETS
  cartographer_node
  occupancy_grid_node
  DESTINATION lib/${PROJECT_NAME})

# google_binary(cartographer_assets_writer
#   SRCS
#     assets_writer_main.cc
#     ros_map_writing_points_processor.h
#     ros_map_writing_points_processor.cc
# )
#
# install(TARGETS cartographer_assets_writer
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
#
# google_binary(cartographer_offline_node
#   SRCS
#     offline_node_main.cc
# )
#
# install(TARGETS cartographer_offline_node
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )
#
# google_binary(cartographer_start_trajectory
#   SRCS
#     start_trajectory_main.cc
# )
#
# install(TARGETS cartographer_start_trajectory
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )
#
# google_binary(cartographer_occupancy_grid_node
#   SRCS
#     occupancy_grid_node_main.cc
# )
#
# install(TARGETS cartographer_occupancy_grid_node
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )
#
# google_binary(cartographer_rosbag_validate
#   SRCS
#     rosbag_validate_main.cc
# )
#
# install(TARGETS cartographer_rosbag_validate
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )
#
# google_binary(cartographer_pbstream_to_ros_map
#   SRCS
#     pbstream_to_ros_map_main.cc
# )
#
# install(TARGETS cartographer_pbstream_to_ros_map
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

=== debian/changelog ===
ros-dashing-cartographer-ros (1.0.9003-1bionic) bionic; urgency=high

  * Switch to using a C-style string for RCLCPP macros.
  * Cleanup the CMakeLists.txt.
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 25 Jan 2021 00:00:00 -0000

ros-dashing-cartographer-ros (1.0.9002-1bionic) bionic; urgency=high

  * Handle multiple ROS messages with the same timestamp (#46 <https://github.com/ros2/cartographer_ros/issues/46>)
  * Contributors: Michel Hidalgo

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 30 Oct 2020 00:00:00 -0000

ros-dashing-cartographer-ros (1.0.9001-1bionic) bionic; urgency=high

  * Init rclcpp first (#41 <https://github.com/ros2/cartographer_ros/issues/41>)
  * Strip ROS args before passing to GFlags (#40 <https://github.com/ros2/cartographer_ros/issues/40>)
  * Fix argument intiialization to allow node to take in params (#39 <https://github.com/ros2/cartographer_ros/issues/39>)
  * Contributors: Emerson Knapp, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 06 Feb 2020 00:00:00 -0000

ros-dashing-cartographer-ros (1.0.0-1bionic) bionic; urgency=high

  * https://github.com/googlecartographer/cartographer_ros/compare/0.3.0...1.0.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 01 Jun 2018 00:00:00 -0000

ros-dashing-cartographer-ros (0.3.0-1bionic) bionic; urgency=high

  * https://github.com/googlecartographer/cartographer_ros/compare/0.2.0...0.3.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 23 Nov 2017 00:00:00 -0000

ros-dashing-cartographer-ros (0.2.0-1bionic) bionic; urgency=high

  * https://github.com/googlecartographer/cartographer_ros/compare/0.1.0...0.2.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 19 Jun 2017 00:00:00 -0000

ros-dashing-cartographer-ros (0.1.0-1bionic) bionic; urgency=high

  * First unstable development release

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 18 May 2017 00:00:00 -0000

=== debian/control ===
Source: ros-dashing-cartographer-ros
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, liblua5.2-dev, libpcl-dev, libyaml-cpp-dev, ros-dashing-ament-cmake, ros-dashing-cartographer, ros-dashing-cartographer-ros-msgs, ros-dashing-nav-msgs, ros-dashing-pcl-conversions, ros-dashing-rclcpp, ros-dashing-sensor-msgs, ros-dashing-tf2, ros-dashing-tf2-eigen, ros-dashing-tf2-msgs, ros-dashing-tf2-ros, ros-dashing-urdfdom-headers, ros-dashing-visualization-msgs, ros-dashing-ros-workspace
Homepage: https://github.com/ros2/cartographer_ros
Standards-Version: 3.9.2

Package: ros-dashing-cartographer-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, liblua5.2-dev, libpcl-dev, libyaml-cpp-dev, ros-dashing-cartographer, ros-dashing-cartographer-ros-msgs, ros-dashing-nav-msgs, ros-dashing-rclcpp, ros-dashing-sensor-msgs, ros-dashing-tf2, ros-dashing-tf2-msgs, ros-dashing-tf2-ros, ros-dashing-visualization-msgs, ros-dashing-ros-workspace
Description: Cartographer is a system that provides real-time simultaneous localization and mapping (SLAM) in 2D and 3D across multiple platforms and sensor configurations.
 This package provides Cartographer's ROS integration.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing" \
		-DCMAKE_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-cartographer-ros//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
